      PARAMETER (jm=1000)
      DIMENSION YS(jm),YOS(jm),Q(jm),H(jm),F(jm),FO(jm),Q0(jm),XX(JM)
	dimension xin(jm)

C        DT=TIME STEP IN secs
C        DX=SPACE STEP
C        IM=MAX VALUES OF I
C        TEND=TOTAL TIME IN secs 
C        A=COEFFICIENT OF THE EQ. (7.5) OR EQ. (K10.30)
C        HH=MEAN DEPTH
C        GAMMA=BREAKING INDEX

      DATA DT,DX,IM,TEND,HH/.25,10.,50,1500000.,2.5/
      DATA GAMMA/.6/

      OPEN(9,FILE='ILDATA.DAT')

C        YOS(I)=INITIAL SHORELINE
C        H(I)=BREAKING HEIGHT
C        DB(I)=BREAKING DEPTH
C        FO(I)=ANGLE AT THE BREAKING POINT 
C        Q0(I)=ON-OFFSHORE SEDIMENT TRANSPORT RATE NEAR SHORELINE

           
     
      DO I=1,IM
      READ(9,*) YOS(I),H(I),FO(I),Q0(I)
	write (*,*) i
      END DO

    

      DO I=1,IM
      YS(I)=YOS(I)
	FO(I)=-FO(I)
      END DO

      TN=0
  100 TN=TN+DT

      DO I=2,IM-1
      F(I)=FO(I)-ATAN((YS(I)-YS(I-1))/DX)
      END DO

      DO I=1,IM
      DB=H(I)/GAMMA
      Q(I)=-(0.025*SQRT(9.81*DB)*H(I)**2*SIN(2.*F(I)))
      END DO

      DO I=2,IM-1
      Q(I)=.05*Q(I+1)+.9*Q(I)+.05*Q(I-1)
      END DO

      Q(1)=Q(2)
	
      Q(IM)=Q(im-1)

      DO I=1,IM-1
      YS(I)=YS(I)+DT/DX*(Q(I+1)-Q(I))/HH+DT*Q0(I)/HH
      END DO




c	YS(im)=YOS(im)

      IF(TN.LT.TEND) GOTO 100

	 OPEN(9,FILE='LINE.DAT')

      DO  I=1,IM
	
      WRITE (9,*) i*dx,YS(I),YOS(i)
      END DO

	STOP
      END



